Attribute VB_Name = "mdlQSort"
'**************************************************
'*  Qsort routine to sort RANDOM File records     *
'*  alphabetically  ON DISK (no limit on filesize)*
'*  Handles Multifield Records FAST with ease     *
'*  Has been used since 1987 with PowerBasic.     *
'*  Converted to VB June 1998                     *
'*  Works for Visual Basic 4.0, 5.0, 6.0          *
'*  Source by:                                    *
'*  Bert Guffens  E-Mail: bguffens@belgacom.net   *
'**************************************************
Option Base 1
'This is a Demo and uses 25 character long Strings
'so they fit the Listboxes. Works equally well with
'Multifield Records containing for Example:
'     Name, address, zip, Tel, E-Mail etc
'No Limit on record size neither

'************************************************
'Must specify field LENGHT. Adjust to your needs.
Public Const LenOfRecord = 25
'************************************************

Dim VI As String * LenOfRecord
Dim AAA As String * LenOfRecord
Dim BBB As String * LenOfRecord
'
Type TestInfo
  Test As String * LenOfRecord '25
End Type

  
Function Sample$(ByVal Place&)
  Get #7, Place&, VI$   'Get a record
  Sample$ = VI$
End Function




Sub Qsort2(Start&, Done&)
  I& = Start&
  J& = Done&
  V& = (Start& + Done&) \ 2
  X$ = Sample$(V&)       'Pick one and compair
  Do
    Do While Sample$(I&) < X$ And I& < Done&
      I& = I& + 1
    Loop
    Do While Sample$(J&) > X$ And J& > Start&
      J& = J& - 1
    Loop
    If I& <= J& Then
      Get #7, I&, AAA$   'Get #1
      Get #7, J&, BBB$   'Get #2
      Put #7, J&, AAA$   'Swap
      Put #7, I&, BBB$   'Swap
      I& = I& + 1
      J& = J& - 1
    End If
  Loop While I& <= J&
  If Start& < J& Then Qsort2 Start&, J&
  If I& < Done& Then Qsort2 I&, Done&
End Sub

Sub QSort(FI$, ByVal LenOfRecord)
  'Open the File with buffer #7
  Open FI$ For Random As #7 Len = LenOfRecord
  'Establish number of records
  Last7& = LOF(7) \ LenOfRecord
  'Sort the file
  Call Qsort2(1, Last7&)
  Close #7  'All done
End Sub


